<?php 
/*** COPYRIGHT NOTICE *********************************************************
 *
 * Copyright 2009-2017 ProjeQtOr - Pascal BERNARD - support@projeqtor.org
 * Contributors : -
 *
 * This file is part of ProjeQtOr.
 * 
 * ProjeQtOr is free software: you can redistribute it and/or modify it under 
 * the terms of the GNU Affero General Public License as published by the Free 
 * Software Foundation, either version 3 of the License, or (at your option) 
 * any later version.
 * 
 * ProjeQtOr is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE.  See the GNU Affero General Public License for 
 * more details.
 *
 * You should have received a copy of the GNU Affero General Public License along with
 * ProjeQtOr. If not, see <http://www.gnu.org/licenses/>.
 *
 * You can get complete code of ProjeQtOr, other resource, help and information
 * about contributors at http://www.projeqtor.org 
 *     
 *** DO NOT REMOVE THIS NOTICE ************************************************/

/** ============================================================================
 * Action is establised during meeting, to define an action to be followed.
 */ 
require_once('_securityCheck.php'); 
class Organization extends OrganizationMain {
  
  public $_sec_Description;
  public $id;
  public $name;
  public $cleHito;
  public $idOrganizationType;
  public $idResource;
  public $_byMet_hierarchicName;
  public $idOrganization;
  public $_spe_arboOrganization;
  public $idUser;
  public $creationDate;
  public $lastUpdateDateTime;
  public $_tab_2_1=array('idle','idleDate','idStatus');
  public $idle;
  public $idleDateTime;
  public $description;
  public $_sec_ValueAlertOverWarningOverOkUnder;
  public $_tab_3_1_smallLabel=array('alertOver','warningOver','okUnder','thresholds');
  public $alertOverPct;
  public $warningOverPct;
  public $okUnderPct;
  public $sortOrder;
  public $OrganizationBudgetElementCurrent;
  public $_sec_synthesis;
  public $_tab_5_4_smallLabel=array('validated','assigned','real','left','reassessed','work','cost','expense','totalCost');
  public $_byMet_validatedWork;
  public $_byMet_assignedWork;
  public $_byMet_realWork;
  public $_byMet_leftWork;
  public $_byMet_plannedWork;
  public $_byMet_validatedCost;
  public $_byMet_assignedCost;
  public $_byMet_realCost;
  public $_byMet_leftCost;
  public $_byMet_plannedCost;
  public $_byMet_expenseValidatedAmount;
  public $_byMet_expenseAssignedAmount;
  public $_byMet_expenseRealAmount;
  public $_byMet_expenseLeftAmount;
  public $_byMet_expensePlannedAmount;
  public $_byMet_totalValidatedCost;
  public $_byMet_totalAssignedCost;
  public $_byMet_totalRealCost;
  public $_byMet_totalLeftCost;
  public $_byMet_totalPlannedCost;
  public $_sec_HierarchicOrganizationProjects;
  public $_spe_Project=array();
  public $_sec_ResourcesOfObject;
  public $_Resource=array();
  public $_spe_affectMembers;
  public $_sec_Link;
  public $_workVisibility;
  public $_costVisibility;
  public $_nbColMax=3;

  public static $_customFields=array(
    'cleHito'
  );

  private static $_fieldsAttributes=array(
    "name"=>"required",
    "idOrganizationType"=>"required",
    "sortOrder"=>"hidden,noImport",
    "_byMet_hierarchicName"=>"readonly,noImport",
    "idleDateTime"=>"readonly,noImport",
    "alertOverPct"=>"noList,notInFilter",
    "warningOverPct"=>"noList,notInFilter",
    "okUnderPct"=>"noList,notInFilter",
    "_spe_Project"=>"noExport",
    "_byMet_validatedWork"=>"readonly",
    "_byMet_assignedWork"=>"readonly",
    "_byMet_realWork"=>"readonly",
    "_byMet_leftWork"=>"readonly",
    "_byMet_plannedWork"=>"readonly",
    "_byMet_validatedCost"=>"readonly,hidden",
    "_byMet_assignedCost"=>"readonly,hidden",
    "_byMet_realCost"=>"readonly,hidden",
    "_byMet_leftCost"=>"readonly,hidden",
    "_byMet_plannedCost"=>"readonly,hidden",
    "_byMet_expenseValidatedAmount"=>"readonly,hidden",
    "_byMet_expenseAssignedAmount"=>"readonly,hidden",
    "_byMet_expenseRealAmount"=>"readonly,hidden",
    "_byMet_expenseLeftAmount"=>"readonly,hidden",
    "_byMet_expensePlannedAmount"=>"readonly,hidden",
    "_byMet_totalValidatedCost"=>"readonly,hidden",
    "_byMet_totalAssignedCost"=>"readonly,hidden",
    "_byMet_totalRealCost"=>"readonly,hidden",
    "_byMet_totalLeftCost"=>"readonly",
    "_byMet_totalPlannedCost"=>"readonly",
    "OrganizationBudgetElementCurrent"=>"hidden",
    "_sec_synthesis"=>"hidden",
    "_sec_ValueAlertOverWarningOverOkUnder"=>"hidden",
    "_sec_Description"=>"",
    "cleHito"=>""
  );
  
  

	
  private static $_staticDisplayStyling=array(
); 
  
  
  private static $_colCaptionTransposition=array(
    "cleHito"=>"plgCleHito"
); 
  
  
  public static $_defaultValues=array(
); 
  
  /** ==========================================================================
	 * Constructor
	 * @param $id the id of the object in the database (null if not stored yet)
	 * @return void
	 */
// ADD BY Marc TABARY - 2017-03-14 - PERIODIC YEAR BUDGET ELEMENT    
	function __construct($id = NULL, $withoutDependentObjects=false, $budgetElement=null) {
		parent::__construct($id,$withoutDependentObjects, $budgetElement);
	}
// END ADD BY Marc TABARY - 2017-03-14 - PERIODIC YEAR BUDGET ELEMENT    
	
// COMMENT BY Marc TABARY - 2017-03-30 - PERIODIC YEAR BUDGET ELEMENT        
//	function __construct($id = NULL, $withoutDependentObjects=false) {
//		parent::__construct($id,$withoutDependentObjects);
//	}
// END COMMENT BY Marc TABARY - 2017-03-30 - PERIODIC YEAR BUDGET ELEMENT        
		/** ==========================================================================
	 * Destructor
	 * @return void
	 */
	function __destruct() {
		parent::__destruct();
	}
	
	

  /** ==========================================================================
   * Return the specific fieldsAttributes
   * @return the fieldsAttributes
   */
  protected function getStaticFieldsAttributes() {
    return array_merge(parent::getStaticFieldsAttributes(),self::$_fieldsAttributes);
  }
 
	/** ==========================================================================
	 * Return the specific styling for fields
	 * @return the fields styling
	 */	
	public function getStaticDisplayStyling() {
	  return self::$_staticDisplayStyling;
	}
 
  /** ============================================================================
   * Set attribut from parent : merge current attributes with those of Main class
   * @return void
   */
  public function setAttributes() {
	  $parentClass=get_class($this)."Main";
	  if (!SqlElement::class_exists($parentClass)) return;
	  $parent=new $parentClass($this->id);
	  if (! method_exists($parent, "setAttributes")) return; 
	  $parent->setAttributes();
	  if (method_exists("SqlElement","mergeAttributesArrays")) {
	    self::$_fieldsAttributes=SqlElement::mergeAttributesArrays(self::$_fieldsAttributes,$parent->getStaticFieldsAttributes());
	  } else {
	    self::$_fieldsAttributes=array_merge_preserve_keys(self::$_fieldsAttributes,$parent->getStaticFieldsAttributes());
	  }
	} 

  /** ============================================================================
   * Return the specific colCaptionTransposition
   * @return the colCaptionTransposition
   */
  protected function getStaticColCaptionTransposition($fld=null) {
    if (isset(self::$_colCaptionTransposition)) {
      return array_merge(parent::getStaticColCaptionTransposition($fld),self::$_colCaptionTransposition);
    } else {
      return parent::getStaticColCaptionTransposition($fld);
    }
  }
 
  /** ==========================================================================
	 * Return the generic defaultValues
	 * @return the layout
	 */
	protected function getStaticDefaultValues() {
	  return self::$_defaultValues;
	}
  }
	?>